"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _immutable = require("immutable");

var _enty = require("enty");

var MapSchema =
/*#__PURE__*/
function (_ObjectSchema) {
  (0, _inherits2.default)(MapSchema, _ObjectSchema);

  function MapSchema(shape) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _classCallCheck2.default)(this, MapSchema);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MapSchema).call(this, shape, options));

    _this.create = function (item) {
      return (0, _immutable.Map)(item);
    };

    _this.merge = function (previous, next) {
      return previous.merge(next);
    };

    return _this;
  }

  return MapSchema;
}(_enty.ObjectSchema);

exports.default = MapSchema;